models.py
from flask import Flask
from flask_sqlalchemy import SQLAlchemy
from flask_login import UserMixin

app = Flask(__name__)
app.config['SQLALCHEMY_DATABASE_URI'] = 'sqlite:///book.sqlite'
app.config['SQLALCHEMY_TRACK_MODIFICATIONS'] = False
db = SQLAlchemy(app)


class User(db.Model, UserMixin):
    id = db.Column(db.Integer, primary_key=True)
    first_name = db.Column(db.String(255))
    last_name = db.Column(db.String(255))
    email = db.Column(db.String, unique=True)
    password = db.Column(db.String)
    tasks = db.relationship('Task', backref='owner')

    def __repr__(self):
        return f'User{self.first_name}{self.email}'


class Task(db.Model):
    id = db.Column(db.Integer, primary_key=True)
    task_name = db.Column(db.String(255))
    due_date = db.Column(db.DateTime())
    status = db.Column(db.String(255))
    todo_owner = db.Column(db.Integer, db.ForeignKey('user.id'))

    def __repr__(self):
        return f'Task{self.task_name}{self.due_date}'

forms.py
from flask_wtf import FlaskForm
from wtforms import StringField, EmailField, PasswordField, SubmitField, DateField, SelectField
from wtforms.validators import DataRequired, EqualTo


class RegisterForm(FlaskForm):
    first_name = StringField('First name', validators=[DataRequired()])
    last_name = StringField('Last name', validators=[DataRequired()])
    email = EmailField('Email', validators=[DataRequired()])
    password = PasswordField('Password', validators=[DataRequired(), EqualTo(fieldname="confirm",
                                                                             message="Your Passwords Do Not Match")])
    confirm = PasswordField("Confirm Password", validators=[DataRequired()])
    submit = SubmitField('Register')


class LoginForm(FlaskForm):
    email = EmailField('Email', validators=[DataRequired()])
    password = PasswordField('Password', validators=[DataRequired()])
    submit = SubmitField('Sign In')


class TodoForm(FlaskForm):
    task_name = StringField('Name', validators=[DataRequired()])
    due_date = DateField('Due Date', validators=[DataRequired()])
    status = SelectField('Status', choices=[('Not Started', 'Not Started'), ('In Progress', 'In Progress'),
                                            ('Complete', 'Complete')])
    submit = SubmitField('Add Task')


class EditForm(FlaskForm):
    task_name = StringField('Name', validators=[DataRequired()])
    due_date = DateField('Due Date', validators=[DataRequired()])
    status = SelectField('Status', choices=[('Not Started', 'Not Started'), ("In Progress", 'In Progress'),
                                            ('Complete', 'Complete')])
    submit = SubmitField('Edit Task')

app.py
from flask import Flask
from models import db
from flask_login import LoginManager
from models import User
from views import todo

# Flask
app = Flask(__name__)
app.config['SECRET_KEY'] = '\x14B~^\x07\xe1\x197\xda\x18\xa6[[\x05\x03QVg\xce%\xb2<\x80\xa4\x00'
app.config['DEBUG'] = True
app.register_blueprint(todo)


login_manager = LoginManager()
login_manager.init_app(app)


@login_manager.user_loader
def load_user(user_id):
    return User.query.get(int(user_id))


# Database
app.config['SQLALCHEMY_DATABASE_URI'] = 'sqlite:///book.sqlite'
app.config['SQLALCHEMY_TRACK_MODIFICATIONS'] = False
app.config['DEBUG'] = True
db.init_app(app)


if __name__ == "__main__":
    app.run(port=3000)

with app.app_context():
    db.create_all()

views.py
from flask import flash, redirect, render_template, request, Blueprint, abort
from werkzeug.security import generate_password_hash, check_password_hash
from models import db, User, Task
from forms import RegisterForm, LoginForm, TodoForm, EditForm
from flask_login import login_user, logout_user, current_user

todo = Blueprint('tasks', __name__)


@todo.route('/')
def home():
    return render_template('home.html')


@todo.route('/register', methods=['POST', 'GET'])
def register():
    form = RegisterForm()
    if request.method == 'POST':
        if form.validate_on_submit:
            user = User(first_name=form.first_name.data,
                        last_name=form.last_name.data,
                        email=form.email.data,
                        password=generate_password_hash(form.password.data)
                        )
            db.session.add(user)
            db.session.commit()
            return redirect('/login')

    else:
        return render_template('register.html', form=form)


@todo.route('/login', methods=['POST', 'GET'])
def login():
    form = LoginForm()
    if form.validate_on_submit:
        user = User.query.filter_by(email=form.email.data).first()
        if user and check_password_hash(user.password, form.password.data):
            login_user(user)
            return redirect('/todos')

    return render_template('login.html', form=form)


@todo.route('/logout', methods=['POST', 'GET'])
def logout():
    logout_user()
    return redirect('/')


@todo.route('/add_todo', methods=['POST', 'GET'])
def add_todo():
    form = TodoForm()
    method = request.method
    if method == 'GET':
        return render_template('add_todo.html', form=form)
    if method == 'POST' and form.validate_on_submit:
        todo = Task(task_name=form.task_name.data, status=form.status.data,
                    due_date=form.due_date.data, todo_owner=current_user.id
                    )
        db.session.add(todo)
        db.session.commit()
        return redirect('/todos')


@todo.route('/todos')
def todos():
    todos = Task.query.filter_by(todo_owner=current_user.id)
    return render_template('todos.html', todos=todos)


@todo.route('/edit_task/<int:id>', methods=['GET', 'POST'])
def edit_task(id):
    form = EditForm()
    task = Task.query.filter_by(id=id, todo_owner=current_user.id).first()
    method = request.method
    if method == 'POST' and form.validate_on_submit():
        task.task_name = form.task_name.data
        task.due_date = form.due_date.data
        task.status = form.status.data
        db.session.add(task)
        db.session.commit()
    if method == 'GET':
        form.task_name.data = task.task_name
        form.due_date.data = task.due_date
        form.status.data = task.status
        return render_template('edit_todo.html', form=form)
    return redirect('/todos')


@todo.route('/delete_task/<int:id>', methods=['GET', 'POST'])
def delete_task(id):
    task = Task.query.filter_by(id=id, todo_owner=current_user.id).first()
    if request.method == 'GET' and task:
        db.session.delete(task)
        db.session.commit()
        return redirect('/todos')
    abort(404)

templates/add_todo.html
{% extends 'base.html'%}
{% block content%}
<section class="container">
   <div class="row">
      <div class="col">
         <form action="" method="post">
            <p>
               {{ form.task_name.label }}<br>
               {{ form.task_name(size =32) }}
            </p>
            <p>
               {{ form.due_date.label }}<br>
               {{ form.due_date(size=32) }}
            </p>
            <p>
               {{ form.status.label }}<br>
               {{ form.status() }}
            </p>
            <p>{{ form.submit() }}</p>
         </form>
      </div>
   </div>
</section>
{% endblock%}

templates/base.html
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link rel="stylesheet" href="static/css/style.css">
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">
</head>

<body>
  <header class="container">
     <div class="row">
         {% if current_user.is_authenticated %}
         <h1 class="col-sm-4">Let's do it, {{current_user.first_name}}?</h1>
         {% elif current_user.is_anonymous %}
         <h2 class="col-sm-4">Let's do it together?</h2>
         {% endif %}
        <nav class="col-sm-8 text-right">
           <p><a href="{{ url_for('tasks.home') }}">Home</a></p>
           {% if current_user.is_anonymous %}
            <p><a href="{{ url_for('tasks.login') }}">Login</a></p>
            <p><a href="{{ url_for('tasks.register') }}">Register</a></p>
           {%else%}
            <p><a href="{{ url_for('tasks.logout') }}">Logout</a></p>
            <p><a href="{{ url_for('tasks.todos') }}">Your tasks</a></p>
           {% endif %}
        </nav>
     </div>
  </header>
  {% block content %}
  {% endblock %}
</body>

templates/edit_todo.html
{% extends 'base.html'%}
{% block content%}
<link rel="stylesheet" href="/static/css/style.css">
</div>
<section class="container">
   <div class="row">
      <div class="col" a>
         <form action="" method="post">
            {{ form.csrf_token }}
            <p>
               {{ form.task_name.label }}<br>
               {{ form.task_name(size =32) }}
            </p>
            <p>
               {{ form.due_date.label }}<br>
               {{ form.due_date(size=32) }}
            </p>
            <p>
               {{ form.status.label }}<br>
               {{ form.status() }}
            </p>
            <p>{{ form.submit() }}</p>
         </form>

      </div>
   </div>
</section>
{% endblock %}

templates/home.html
{% extends 'base.html'%}
{% block content%}
<div class="container">
   <div class="row">
      <div class="col">
         
      </div>
   </div>
</div>
<section class="container">
   <div class="row">
      {% if current_user.is_anonymous %}
      <div class="col" a>
        <p>You need to authorize to be organized =)</p>
      </div>
      {% endif %}
   </div>
   <img src="static/todo_img.jpeg" alt="To do list photo for home page" width="700" height="700">
</section>

{% endblock %}

templates/login.html
{% extends 'base.html'%}
{% block content%}
<section class="container">
   <div class="row">
      <div class="col">
         <form action="" method="post">
            <p>
               {{ form.email.label }}<br>
               {{ form.email(size =32) }}
            </p>
            <p>
               {{ form.password.label }}<br>
               {{ form.password(size=32) }}
            </p>
             <button type="submit" class="btn btn-primary">Login</button>
            <a href="{{ url_for('tasks.register') }}">Create a New Account</a>
         </form>
      </div>
   </div>
</section>
{% endblock %}

templates/register.html
{% extends 'base.html'%}
{% block content%}
<section class="container">
   <div class="row">
      <div class="col">
         <form action="" method="post">
            <p>
               {{ form.first_name.label }}<br>
               {{ form.first_name(size =32) }}
            </p>
            <p>
               {{ form.last_name.label }}<br>
               {{ form.last_name(size=32) }}
            </p>
            <p>
               {{ form.email.label }}<br>
               {{ form.email(size=32) }}
            </p>
            <p>
               {{ form.password.label }}<br>
               {{ form.password(size=32) }}
            </p>
            <p>
               {{ form.confirm.label }}<br>
               {{ form.password(size=32) }}
            </p>
            <button type="submit" class="btn btn-primary">Register</button>
            <a href="{{ url_for('tasks.login') }}">Login into existing account</a>

         </form>

      </div>
   </div>
</section>
{% endblock %}

templates/todos.html
{% extends "base.html" %}
{% block content %}
<script src="static/js/script.js"></script>


<!--Todo Table-->
<br> <br>
    <div class="container table-responsive">
        <div style="text-align: right;">

        <a type="button" href="{{ url_for('tasks.add_todo') }}" class="btn btn-outline-info btn-sm"
           style="border-color:blue; color:blue;font-size:20px; background-color:white">Add Task</a>
        </div>

    <table id="myTable" class="table">
        <thead>
        <br>
        <tr>
            <th class="task-id" onclick="sortTable(0)"># <svg xmlns="http://www.w3.org/2000/svg" width="16"
            height="16" fill="currentColor" class="bi bi-sort-down" viewBox="0 0 16 16"><path d="M3.5 2.5a.5.5 0 0 0-1
            0v8.793l-1.146-1.147a.5.5 0 0 0-.708.708l2 1.999.007.007a.497.497 0 0 0 .7-.006l2-2a.5.5 0 0 0-.707-.708L3.5 11.293V2.5zm3.5 1a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zM7.5 6a.5.5 0 0 0 0 1h5a.5.5 0 0 0 0-1h-5zm0 3a.5.5 0 0 0 0 1h3a.5.5 0 0 0 0-1h-3zm0 3a.5.5 0 0 0 0 1h1a.5.5 0 0 0 0-1h-1z">
            </path></svg></th>
            <th class="task"onclick="sortTable(1)">Task Name <svg xmlns="http://www.w3.org/2000/svg" width="16"
            height="16" fill="currentColor" class="bi bi-sort-down" viewBox="0 0 16 16"><path d="M3.5 2.5a.5.5 0 0 0-1
            0v8.793l-1.146-1.147a.5.5 0 0 0-.708.708l2 1.999.007.007a.497.497 0 0 0 .7-.006l2-2a.5.5 0 0 0-.707-.708L3.5 11.293V2.5zm3.5 1a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zM7.5 6a.5.5 0 0 0 0 1h5a.5.5 0 0 0 0-1h-5zm0 3a.5.5 0 0 0 0 1h3a.5.5 0 0 0 0-1h-3zm0 3a.5.5 0 0 0 0 1h1a.5.5 0 0 0 0-1h-1z">
            </path></svg></th>
            <th class="status"onclick="sortTable(2)">Status <svg xmlns="http://www.w3.org/2000/svg" width="16"
            height="16" fill="currentColor" class="bi bi-sort-down" viewBox="0 0 16 16"><path d="M3.5 2.5a.5.5 0 0 0-1
            0v8.793l-1.146-1.147a.5.5 0 0 0-.708.708l2 1.999.007.007a.497.497 0 0 0 .7-.006l2-2a.5.5 0 0 0-.707-.708L3.5 11.293V2.5zm3.5 1a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zM7.5 6a.5.5 0 0 0 0 1h5a.5.5 0 0 0 0-1h-5zm0 3a.5.5 0 0 0 0 1h3a.5.5 0 0 0 0-1h-3zm0 3a.5.5 0 0 0 0 1h1a.5.5 0 0 0 0-1h-1z">
            </path></svg></th>
            <th class="update" onclick="sortTable(3)">Due Date <svg xmlns="http://www.w3.org/2000/svg" width="16"
            height="16" fill="currentColor" class="bi bi-sort-down" viewBox="0 0 16 16"><path d="M3.5 2.5a.5.5 0 0 0-1
            0v8.793l-1.146-1.147a.5.5 0 0 0-.708.708l2 1.999.007.007a.497.497 0 0 0 .7-.006l2-2a.5.5 0 0 0-.707-.708L3.5 11.293V2.5zm3.5 1a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zM7.5 6a.5.5 0 0 0 0 1h5a.5.5 0 0 0 0-1h-5zm0 3a.5.5 0 0 0 0 1h3a.5.5 0 0 0 0-1h-3zm0 3a.5.5 0 0 0 0 1h1a.5.5 0 0 0 0-1h-1z">
            </path></svg></th>
            <th class="update">Edit</th>
            <th class="update">Remove</th>

        </tr>
        </thead>

        <tbody>
        {% for todo in todos %}
            <tr>
                <td>{{todo.id}}</td>
                <td>{{todo.task_name}}</td>

                {% if todo.status == "Not Started" %}
                    <td><span class="btn-outline-warning" data-source="{{todo.id}}">{{todo.status}}</span></td>
                {%endif%}
                {% if todo.status == "In Progress" %}
                    <td><span class="btn-outline-secondary" data-source="{{todo.id}}">{{todo.status}}</span></td>
                {%endif%}
                {% if todo.status == "Complete" %}
                    <td><span class="btn-outline-success" data-source="{{todo.id}}">{{todo.status}}</span></td>
                {%endif%}

                <td> {{todo.due_date.strftime("%b %d %Y")}} </td>
                <td><a type="button" class="btn btn-warning" href="{{ url_for('tasks.edit_task', id=todo.id) }}"> Edit </a></td>

                <td><a type="button" class="btn btn-danger" href="{{ url_for('tasks.delete_task', id=todo.id) }}"> Delete </a></td>

            </tr>
        {% endfor %}

        </tbody>
    </table>
    </div>


{% endblock %}